﻿Type=Class
Version=3.8
B4A=true
@EndOfDesignText@
'Class module
Sub Class_Globals
	Private mIsRunning As Boolean
	Private TH As Thread
	Private mModule As Object
	Private mUSBMan As MidiUsbManager
	Dim Interrupt As Boolean
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(Module As Object,USBMan As MidiUsbManager)
	mModule = Module
	mUSBMan = USBMan
	TH.Initialise("TH")
End Sub
Sub Start
	TH.Start(Me,"USBInThread",Null)
End Sub
Sub USBInThread
	mIsRunning = True
	Dim inBytes(mUSBMan.inEndPoint.MaxPacketSize) As Byte
	Dim MsgType As Int
	Dim i As Int
	Dim byteCount As Int
	'Parse the incoming data
	Do While True
		byteCount = mUSBMan.Connection.BulkTransfer(mUSBMan.inEndPoint,inBytes,inBytes.Length,0)
		If byteCount > 0 Then
			i = 0
			Do While i < byteCount
				MsgType = Bit.AND(inBytes(i),0xF)
				Dim MidiMsg() As Byte
				Select MsgType
					Case 8,9,0xb,0xe
						Dim MidiMsg(4) As Byte
						MidiMsg(0) = inBytes(i)
						MidiMsg(1) = inBytes(i+1)
						MidiMsg(2) = inBytes(i+2)
						MidiMsg(3) = inBytes(i+3)
						i=i+4
					Case 0xc
						Dim MidiMsg(3) As Byte
						MidiMsg(0) = inBytes(i)
						MidiMsg(1) = inBytes(i+1)
						MidiMsg(2) = inBytes(i+2)
						i=i+3
					Case Else
						i=i+3
						
				End Select
				If MidiMsg.Length > 0 Then 
					TH.RunOnGuiThread("ShowMessage",Array As Object(MidiMsg))
					'If midi thru requested play the incoming data directly to the output
					If mUSBMan.MidiThru Then mUSBMan.Connection.BulkTransfer(mUSBMan.OutEndPoint,MidiMsg,MidiMsg.Length,0)
				End If
			Loop
		End If
		If Interrupt Then Exit
	
	Loop
End Sub
Sub TH_Ended(endedOK As Boolean, error As String)
	'Thread Finished
	Interrupt = False
	mIsRunning = False
	CallSub(mModule,"MidiIN_Finished")
End Sub
Sub ShowMessage(Msg() As Byte)

	Dim Data(Msg.Length) As Object
	For i = 0 To Msg.Length - 1
		Data(i) = Msg(i)
	Next
	'Create the Formatter Object
    Dim Format As JavaObject
    Format.InitializeStatic("java.lang.String")
	
	Dim FormatString As String = "In   %#4x  %#4x %#4x"
	If Data.Length = 4 Then FormatString = FormatString  & " %#4x" 
	
	LogColor(Format.RunMethod("format",Array As Object(FormatString,Data)),Colors.Gray)
End Sub
Sub getIsRunning As Boolean
	Return mIsRunning
End Sub